package com.its.op.service.its.rse;

import com.its.op.dao.repository.its.rse.TbRseOffrDrctRepository;
import com.its.op.dto.its.rse.TbRseOffrDrctDto;
import com.its.op.entity.its.rse.TbRseOffrDrct;
import com.its.op.entity.its.rse.TbRseOffrDrctKey;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbRseOffrDrctService {

    private final TbRseOffrDrctRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbRseOffrDrct requireOne(TbRseOffrDrctKey id) throws NoSuchElementException {
        Optional<TbRseOffrDrct> info = this.repo.findById(id);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + id);
        }
//        return this.repo.findById(id)
//                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbRseOffrDrctDto> findAll() {
        List<TbRseOffrDrctDto> result = new ArrayList<>();
        List<TbRseOffrDrct> data = this.repo.findAll();
        for (TbRseOffrDrct entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbRseOffrDrctDto findById(TbRseOffrDrctKey id) {
        TbRseOffrDrct entity = requireOne(id);
        return entity.toDto();
    }

    // 데이터 변경
    @Transactional
    public TbRseOffrDrctDto updateById(TbRseOffrDrctKey id, TbRseOffrDrctDto.TbRseOffrDrctUpdReq req) {
        TbRseOffrDrct entity = requireOne(id);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbRseOffrDrctDto> mergeInfoList(List<TbRseOffrDrctDto.TbRseOffrDrctUpdReq> reqList) {
        List<TbRseOffrDrctDto> result = new ArrayList<>();
        for (TbRseOffrDrctDto.TbRseOffrDrctUpdReq req : reqList) {
            TbRseOffrDrct obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbRseOffrDrctDto mergeInfo(TbRseOffrDrctDto.TbRseOffrDrctUpdReq req) {
        TbRseOffrDrct obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbRseOffrDrctDto deleteById(TbRseOffrDrctKey id) {
        TbRseOffrDrct entity = requireOne(id);
        this.repo.deleteById(id);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbRseOffrDrctDto> deleteByIds(List<TbRseOffrDrctKey> ids) {
        List<TbRseOffrDrctDto> result = new ArrayList<>();
        for (TbRseOffrDrctKey id : ids) {
            Optional<TbRseOffrDrct> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

}
